﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms.VisualStyles;

namespace Airbus
{
    //расширение для класса DrawingPlane (класс для сохранения в файл колекций объектов)
    internal static class ExtentionPlane
    {
        //разделитель  для записи информации по объекту в файл
        private static readonly char _separatorForObject = ':';

        //создание объекта из строки
        public static DrawningAirbus CreateDrawningPlane(this string info)
        {
            string[] strs = info.Split(_separatorForObject);

            //если простой самолёт
            if(strs.Length == 3)
            {
                return new DrawningAirbus(Convert.ToInt32(strs[0]), Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }

            //если аэробус
            if(strs.Length == 6)
            {
                return new DrawningSuperAirbus(Convert.ToInt32(strs[0]), Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                    Color.FromName(strs[3]), Convert.ToBoolean(strs[4]), Convert.ToBoolean(strs[5]));
            }

            return null;
        }

        //сохраниние объекта в строку
        public static string GetDataForSave(this DrawningAirbus drawingPlane)
        {
            var plane = drawingPlane.Airbus;
            var str = $"{plane.Speed}{_separatorForObject}{plane.Weight}{_separatorForObject}{plane.CorpusColor.Name}";

            //если объект не расширеный
            if(plane is not EntitySuperAirbus airbus)
            {
                return str;
            }

            return $"{str}{_separatorForObject}{airbus.AddColor.Name}{_separatorForObject}" +
                $"{airbus.AddEngine}{_separatorForObject}{airbus.AddСompartment}";

        }
    }
}
