﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Airbus
{
    internal class StarWarsMap : AbstractMap
    {

        Random rnd = new Random();

        //цвет выстрела из лазера
        Color randomColor = new Color();

        //цвет закрытого участка
        Brush barriedColor;

        //цвет открытого участка
        Brush roadColor = new SolidBrush(Color.DarkBlue);

        protected override void DrawBarrierPart(Graphics g, int i, int j)
        { 
            randomColor = Color.FromArgb(rnd.Next(256), rnd.Next(256), rnd.Next(256));
            barriedColor = new SolidBrush(randomColor);
            g.FillRectangle(barriedColor, i * _size_x, j * _size_y, _size_x, _size_y);
        }

        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(roadColor, i * _size_x, j * _size_y, _size_x, _size_y);
        }

        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int counter = 0;

            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            }

            while (counter < 50)
            {
                int x = _random.Next(0, 100);
                int y = _random.Next(0, 100);

                if (_map[x, y] == _freeRoad)
                {
                    _map[x, y] = _barrier;
                    counter++;
                }
            }
        }
    }
}
